/*--------------------------------------------------------------------*/
/*Copyright 1994 Lars Olofsson                                        */
/*Last modified 1994-06-21 by Lars Olofsson <larso@wmute.trillium.se> */
/*                                                                    */
/*Please feel free to modify, changing 'Last Modified' above to       */
/*'Modified' and adding 'Last Modified' with date and your name.      */
/*                                                                    */
/*Description: Command to uuencode and send a file to receiver.       */
/*Usage: GETF <file>                                                  */
/*--------------------------------------------------------------------*/


/* This command requires the use of some UUENCODE program, here */
/* named uuencode, which creates a file with the extension of .UUE */

ARG arg1 arg2

IF arg1="" THEN CALL USAGE
IF arg2<>"" THEN CALL USAGE

input=LINEIN("fileserver.ini")
PARSE VAR input "=" filepath
file=filepath"\"arg1

/* Does the file exist at all ? */

IF STREAM(file,'c','query exists')="" THEN CALL NOTFOUND

/* Get the information on the second line of the user.ini file*/

input=LINEIN("user.ini")
input=LINEIN("user.ini")
PARSE VAR input "=" returnadress

/*UUEncode and send the file*/

/* Remove the path from the filename */
sendfile=arg1
DO UNTIL LENGTH(sendfile)=0
   oldsendfile=sendfile
   PARSE VAR oldsendfile "\" sendfile
END
sendfile=oldsendfile

/*Do the rest*/
"@uuencode" file
"@wmsend" sendfile".UUE -s " arg1 returnadress
"@del" sendfile".UUE"
SAY arg1 "sent to" returnadress
EXIT

USAGE:
SAY "There was an error in your specified command."
SAY "The correct usage is: GETF <file>"

NOTFOUND:
SAY "File "arg1" not found."
